//+------------------------------------------------------------------+
//|                                         RightWorkWithHistory.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//| űʼ                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//--- ֻڽʷıΪtrue
   bool TradeHistoryChanged=true;
//--- Ǽ齻ʷĸı䣬бҪTrendHistoryChangedΪtrue
   TradeHistoryChanged=true; // ʵзһУʾҪʷĸı

//--- 齻ʷǷиı
   if(!TradeHistoryChanged) return;

//--- ʷѾı䣬Ҫ뻺
//--- ȡʷֱǰķʱ
   datetime end=TimeCurrent();
//--- ǰʼ
   datetime start=end-3*PeriodSeconds(PERIOD_D1);
//--- ȡĽʷ
   HistorySelect(start,end);
//--- ûеʷĿ
   int history_orders=HistoryOrdersTotal();
//--- ж
   for(int i=0;i<history_orders;i++)
     {
      //--- ʷеĶ
      ulong ticket=HistoryOrderGetTicket(i);
      //--- ȡ
      //--- ݶŶȡ
      long order_magic     =HistoryOrderGetInteger(ticket,ORDER_MAGIC);
      datetime time_setup  =HistoryOrderGetInteger(ticket,ORDER_TIME_SETUP);
      datetime time_done   =HistoryOrderGetInteger(ticket,ORDER_TIME_DONE);
      long position_ID     =HistoryOrderGetInteger(ticket,ORDER_POSITION_ID);
      ENUM_ORDER_TYPE type =(ENUM_ORDER_TYPE)HistoryOrderGetInteger(ticket,ORDER_TYPE);
      double volume_initial=HistoryOrderGetDouble(ticket,ORDER_VOLUME_INITIAL);
      double price_open    =HistoryOrderGetDouble(ticket,ORDER_PRICE_OPEN);
      string order_comment =HistoryOrderGetString(ticket,ORDER_COMMENT);
      string order_symbol  =HistoryOrderGetString(ticket,ORDER_SYMBOL);
      PrintFormat("%d:  #%d %s  %s µ %s, ִ %s ۸ %G  posID=%d",
                  i,ticket,EnumToString(type),order_symbol,TimeToString(time_setup),
                  TimeToString(time_done),price_open,position_ID);
     }

//--- ȡеĽ
   int deals=HistoryDealsTotal();
//--- н
   for(int i=0;i<deals;i++)
     {
      //--- ý׵
      ulong ticket=HistoryDealGetTicket(i);
      //--- ȡ׵
      //--- ݵŶȡ
      long order_magic     =HistoryDealGetInteger(ticket,DEAL_MAGIC);
      datetime time        =HistoryDealGetInteger(ticket,DEAL_TIME);
      long position_ID     =HistoryDealGetInteger(ticket,DEAL_POSITION_ID);
      ENUM_ORDER_TYPE type =(ENUM_ORDER_TYPE)HistoryDealGetInteger(ticket,DEAL_TYPE);
      double volume        =HistoryDealGetDouble(ticket,DEAL_VOLUME);
      double price         =HistoryDealGetDouble(ticket,DEAL_PRICE);
      string order_comment =HistoryDealGetString(ticket,DEAL_COMMENT);
      string deal_symbol   =HistoryDealGetString(ticket,DEAL_SYMBOL);
      PrintFormat("%d:  #%d %s  %G Ʒ %s ʱ %s ۸ %G,  posID=%d",
                  i, ticket, EnumToString(type),volume, deal_symbol, TimeToString(time),
                  price,position_ID);
     }
  }
//+------------------------------------------------------------------+
